/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/
void Control::init()
{
data=NULL;
imview=NULL;
mx[0]=1.0;
mx[1]=0;
mx[2]=0;
mx[3]=1.0;
}

// This is for reading scanned diffraction mode images
void Control::fileOpenDif()
{
QString s( QFileDialog::getOpenFileName() );
if ( s.isNull() ) return;
//QFile file(s);

QApplication::setOverrideCursor( waitCursor );

if (data) delete data;
data=new EMData;
data->readImage(s.data(),0);
newData();
//imResized(imview->width(),imview->height());

QApplication::restoreOverrideCursor( );

}

// This reads real-space images (and does an FFT)
void Control::fileOpen()
{
QString s( QFileDialog::getOpenFileName() );
if ( s.isNull() ) return;
//QFile file(s);

QApplication::setOverrideCursor( waitCursor );
EMData d2;
d2.readImage((const char *)s,0);
if (d2.isComplex()) {
    QMessageBox::warning ( NULL, "No FFTs", "Sorry, qindex currently demands its right to perform its own FFTs\nPlease load a real-space image.", 1,0,0 );
    return;
}
d2.normalize();
if (data) delete data;

// We cannot tolerate odd image sizes
if (d2.xSize()%2!=0 || d2.ySize()%2!=0) {
    EMData *d3=d2.clip(0,0,d2.xSize()-(d2.xSize()%2),d2.ySize()-(d2.ySize()%2));
    data=d3->doFFT();
    d3->gimmeFFT();
    delete d3;
}
else {
    data=d2.doFFT();
    d2.gimmeFFT();
}
newData();

//imResized(imview->width(),imview->height());

QApplication::restoreOverrideCursor( );

}

void Control::fileExit()
{
exit(0);
}

void Control::helpIndex()
{
About *abo = new About();
abo->show();
}

void Control::helpContents()
{
About *abo = new About();
abo->show();
}

void Control::helpAbout()
{
About *abo = new About();
abo->show();
}

void Control::newData()
{
    if (!imview) {
	imview=new Image();
    }
    imview->setData(data);
//    imview->show();
 //   imview->resize(data->xSize()<800?data->xSize():800,data->ySize()<800?data->ySize():800);
  //  imview->setScale(1.0);
//    imview->setBC(.35,.5);
    
 //   connect(imview,SIGNAL(mouseMoveAll(QMouseEvent *)),this,SLOT(imageMouseMove(QMouseEvent *)));
    connect(imview,SIGNAL(mousePress(QMouseEvent *)),this,SLOT(imageMouseSel(QMouseEvent *)));
    connect(imview,SIGNAL(mouseMove(QMouseEvent *)),this,SLOT(imageMouseSelMove(QMouseEvent *)));
    
    connect(imview,SIGNAL(resized(int,int)),SLOT(imResized(int,int)));
    connect(imview,SIGNAL(moved(int,int)),SLOT(imMoved(int,int)));
    imview->resize(data->xSize()<800?data->xSize():800,data->ySize()<800?data->ySize():800);
    imview->setScale(1.0);
    imview->setBC(.35,.5);
    imview->show();
    
    // Display the image size
    QString s;
    if (data->isComplex()) s.sprintf("%0d x %0d",data->xSize()-2,data->ySize());
    else s.sprintf("%0d x %0d",data->xSize(),data->ySize());
    imdimW->setText(s);
    
    newUCP();
}

// New unit cell parameters
void Control::newUCP()
{
if (!data) return;
float angh=atof((const char *)anghW->text())*PI/180.0;
float angk=atof((const char *)anghkW->text())*PI/180.0+angh;
float cellh=atof((const char *)cellhW->text());
float cellk=atof((const char *)cellkW->text());
float ap=atof((const char *)apixW->text());

if (cellh<=0||cellk<=0||ap<=0) return;	// invalid parameters, keep the old ones

apix=ap;
mx[0]=cos(angh)/cellh;	// h dx
mx[1]=sin(angh)/cellh;	// h dy
mx[2]=cos(angk)/cellk;	// k dx
mx[3]=sin(angk)/cellk;	// k dy

regrid();
}

#define CIRSIZE 7
void Control::regrid()
{
    if (!data) return;
    imview->clearShapes();
   
    // These are how much s changes per pixel
    dsy=1.0/(float)(apix*data->ySize());
    if (data->isComplex()) dsx=1.0/(float)(apix*(data->xSize()-2));
    else dsx=1.0/(float)(apix*data->xSize());
    
    int xc=data->xSize()/2;
    int yc=data->ySize()/2;
    QColor color(24,24,192);
    QColor color2(64,192,192);
    QColor color3(64,192,192);
    ImShape *ts;
    int h,k,hs,ks;
    for (hs=-1; hs<2; hs+=2) {
	for (ks=-1; ks<2; ks+=2) {
	    for (h=0; h<100; h++) {
		int got1=0;
		for (k=0; k<100; k++) {
		    int x=xc+round((hs*h*mx[0]+ks*k*mx[2])/dsx);
		    int y=yc+round((hs*h*mx[1]+ks*k*mx[3])/dsy);
		    if (x+CIRSIZE>=data->xSize() || x<0 || y+CIRSIZE>=data->ySize() || y<0) break;
		    got1=1;
	    
		    ts=new ImShape;
		    ts->type=ImShape::CIRCLE;
		    ts->x0=x-CIRSIZE/2-1;
		    ts->y0=y-CIRSIZE/2;
		    ts->x1=ts->y1=CIRSIZE;
		    if (h==0 && k==0) ts->color=color;
		    else if (h==0) ts->color=color2;
		    else if (k==0) ts->color=color3;
		    else ts->color=color;
		    ts->user=h*hs;
		    ts->user2=k*ks;
		    imview->addShape(ts);
		}
		if (!got1) break;
	    }
	}
    }
    hilight();
 }


void Control::hilight()
{
int i,h,k;
h=inthW->value();
k=intkW->value();
    
    for (i=0; i<imview->nShapes(); i++) {
	ImShape *sh=imview->shapeAt(i);
	if (sh->user==h && sh->user2==k) {
	    imview->hilight(i); 
	    break; 
	}
    }
    
    float x=(h*mx[0]+k*mx[2]);
    float y=(h*mx[1]+k*mx[3]);
        
    if (x==0 || y==0) {
	peakRW->setText(QString("-"));
	peakAW->setText(QString("-"));
    }
    else {
	peakRW->setText(QString::number(1/hypot(x,y),'f',2));
	peakAW->setText(QString::number(atan2(y,x)*180./PI,'f',2));
    }
    
    if (data->isComplex()) {
	int imx=round((h*mx[0]+k*mx[2])/dsx)*2;
	int imy=round((h*mx[1]+k*mx[3])/dsy);
	if (imx<0) { imx=-imx; imy=data->ySize()/2-imy; }
	else { imy+=data->ySize()/2; }

	float sum=0;
	int X,Y;
	for (Y=imy-3; Y<=imy+3; Y++) {
	    for (X=imx-6; X<=imx+6; X+=2) {
		sum+=SQR(data->valueAtSafe(X,Y));
	    }
	}
	sum*=data->xSize()*data->ySize()/49.0;
	peakIW->setText(QString::number(sum,'g',3));
    }
   imview->update();
}




void Control::imageMouseMove(QMouseEvent *e)
{
float x=(imview->pxtodx(e->x())-data->xSize()/2)*dsx;
float y=(imview->pytody(e->y())-data->ySize()/2)*dsy;
if (x==0 && y==0) {
    imview->setCaption("Cursor: 0, 0");
    return;
}

QString s;
s.sprintf("Cursor: %d, %d -> %1.2f A^-1 %1.2f deg",(int)round(x),(int)round(y),1.0/hypot(x,y),atan2(y,x));

imview->setCaption(s);
}


void Control::imageMouseSel( QMouseEvent *e )
{
int i,j=0;
float x=imview->pxtodx(e->x());
float y=imview->pytody(e->y());

    for (i=0; i<imview->nShapes(); i++) {
	ImShape *sh=imview->shapeAt(i);
	
	if (x>sh->x0 && y>sh->y0 && x<sh->x0+sh->x1 && y<sh->y0+sh->y1) {
	    inthW->setValue(sh->user);
	    intkW->setValue(sh->user2);
	    j=1;
	    break;
	}
    }

    if (!j) { 
	inthW->setValue(0);
	intkW->setValue(0);
    }
    
}

void Control::imageMouseSelMove( QMouseEvent *e )
{
int h=inthW->value();
int k=intkW->value();

float x=(imview->pxtodx(e->x())-data->xSize()/2)*dsx;
float y=(imview->pytody(e->y())-data->ySize()/2)*dsy;

float r=hypot(x,y);
float a=atan2(y,x)*180.0/PI;
float angh=atof((const char *)anghW->text());

if (h==0 && k!=0) {
    cellkW->setText(QString::number((float)k/r));
    anghkW->setText(QString::number(a-angh));
}

if (k==0 && h!=0) {
    float anghk=atof((const char *)anghkW->text());
    cellhW->setText(QString::number((float)h/r));
    anghW->setText(QString::number(a));
    anghkW->setText(QString::number(anghk-(a-angh)));
}

}


void Control::cricleOnOff()
{
    imview->clearShapes();
  
}


void Control::panned(float x, float y)
{
//    printf("thsi function was call\n");
    imview->setOrigin(x,y);
}
void Control::imResized(int w, int h)
{
 //   printf("thsi function was call\n");
    float xh,yh;
    float ls=imview->lscale;
    if (!ls) ls=1.0;

    if (data->xSize()>data->ySize())
	pan->resize(150,150*data->ySize()/data->xSize());
    else pan->resize(150*data->xSize()/data->ySize(),150);
    pan->setXRange(0,data->xSize()*ls-w);
    pan->setYRange(0,data->ySize()*ls-h);
    if (data->xSize()*ls<w) xh=1.0;
    else xh=w/(data->xSize()*ls);
    if (data->ySize()*ls<h) yh=1.0;
    else yh=h/(data->ySize()*ls);
    //printf("xh %f, yh: %f \n", xh, yh);
    pan->setHandleSize(xh,yh);
    pan->update();
}

void Control::imMoved( int x, int y)
{
    pan->setValue(x,y);
}

