#include "SliceImage.h"
#include <qfile.h>
#include <qdragobject.h>
#include <qprinter.h>
#include <qmessagebox.h>

int SIcolormap[255][3] = {
	8,8,8,
	8,0,0,
	0,8,0,
	0,6,0,
	8,8,0,
	8,0,8,
	0,8,8,
	8,4,4,
	4,8,4,
	4,4,8,
	8,8,4,
	8,4,8,
	4,8,8,
	8,6,6,
	6,8,6,
	6,6,8,
	8,8,6,
	8,6,8,
	2,8,8,
	8,2,2,
	2,8,2,
	2,2,8,
	8,8,2,
	8,2,8,
	2,8,8,
	0,0,0
};

void colorize(void *SI,int coord,unsigned char *tri) {
SliceImage *si=(SliceImage *)SI;
EMData *segdata = si->getSegData();
int segdisp = si->getSegDisp();

tri[1]=tri[2]=tri[0];
if (!segdata) ; 
else if (segdisp>=0) {
	if ((int)segdata->valueAt(coord,0)==segdisp) { 
		tri[0]=(unsigned char)((int)tri[0]*3/4);
		tri[1]=(unsigned char)((int)tri[1]*3/4);
	}
}
else {
	int v=(int)segdata->valueAt(coord,0);
	if (v) {
		if (v>24) v=25;
		tri[0]=(unsigned char)((int)tri[0]*SIcolormap[v][0]/8);
		tri[1]=(unsigned char)((int)tri[1]*SIcolormap[v][1]/8);
		tri[2]=(unsigned char)((int)tri[2]*SIcolormap[v][2]/8);
	}
}

}

SliceImage::SliceImage(QWidget* parent,const char* name):Image(parent,name) {
segdata=NULL;
max=1.0;
min=0;
segdisp=-1;
drawseg=1;
drawrad=1;
}

SliceImage::~SliceImage() {

}

void SliceImage::paintEvent( QPaintEvent *pe ) {
char *d;
float mm,b,me;
int i,j,sx,sy;
ImShape *cur;
EMData *data = datar;
if (datar && showfft && !(datar->isComplex())) { data=datar->doFFT(); data->ri2ap(); }

//sz=width()<height()?width():height();
sx=qpm->width();
sy=qpm->height();
if (data && scale==0) {
	lscale=(float)sy/(data->ySize()-.5);
	originx=originy=0;
}
else lscale=scale;

if (!data) {
	qp->begin(this);
	qp->fillRect(0,0,size().width(),size().height(),white);
	qp->setPen(black);
	qp->drawText(0,0,size().width(),size().height(),AlignCenter,mtstr.data());
	qp->end();
//	printf(" NULL\n");
	return;
}
else if (needupd||qpd) {
	if (data->zSize()==1) {

		mm=(max-min)/2.0;
		me=(max+min)/2.0;
		b=mm*brite*2.0;
		mm*=(1.0-sqrt(cont));

		d=(char *)malloc(sx*sy*3+80);
		memset(d,127,sx*sy*3+80);

		sprintf(d,"P6\n%d %d\n255\n",sx,sy);
		i=strlen(d);
		data->renderAmp24((unsigned char *)d+i,originx/lscale,originy/lscale,sx,sy,sx*3,
			lscale,invert?254:1,invert?1:254,me-mm-b,me+mm-b,this,colorize);

		if (imc) imc->imageMinMax(me-mm-b,me+mm-b);
		qpm->loadFromData((uchar *)d,(uint)(i+sx*sy*3));

		free(d);
		needupd=0;
	}
	else if (dcopy) {
		EMData *pr;
		
		if (mode) {
			pr=dcopy->project3d(angle.alt(),angle.az(),angle.phi(),-3,(brite+1.0)*dcopy->Max()/2.0);
			mm=-pr->Min()<pr->Max()?pr->Max():-pr->Min();
//			b=mm*brite;
			mm*=(1.0-cont);
		} else {
			pr=dcopy->project3d(angle.alt(),angle.az(),angle.phi(),-2);
			mm=-pr->Min()<pr->Max()?pr->Max():-pr->Min();
			b=mm*brite;
			mm*=(1.0-cont);
		}

		d=(char *)malloc(sx*sy+80);
		memset(d,0,sx*sy+80);

		sprintf(d,"P5\n%d %d\n255\n",sx,sy);
		i=strlen(d);
		if (pr->isComplex()) pr->ri2ap();
		pr->renderAmp8((unsigned char *)d+i,originx/lscale,originy/lscale,sx,sy,sx,
			lscale,invert?254:1,invert?1:254,-mm-b,mm-b);

		if (imc) imc->imageMinMax(-mm-b,mm-b);
		qpm->loadFromData((uchar *)d,(uint)(i+sx*sy));

		free(d);
		needupd=0;
	}
}

if (shapes.count()==0 && select.type==ImShape::NONE) bitBlt( this, 0,0, qpm );
else {
//	QPixmap qpm2(*qpm);

//	qp->begin(&qpm2);
//	bitBlt( this, 0,0, qpm );
	bitBlt( this,pe->rect().topLeft(),qpm,pe->rect());
	qp->begin(this);
	qp->setPen(red);

	shapes.append(&select);
	for (cur=shapes.first(); cur!=NULL; cur=shapes.next()) {
//printf("%d %d  %d %d\n",cur->x0,cur->y0,dxtopx(cur->x0),dytopy(cur->y0));

		qp->setPen(QPen(cur->color,cur->lw));
		if (cur->type==ImShape::FILL_CIRCLE) qp->setBrush(QBrush(cur->color,SolidPattern));
		switch(cur->type) {
		case ImShape::LINE:
			qp->drawLine(dxtopx(cur->x0),dytopy(cur->y0),dxtopx(cur->x1),dytopy(cur->y1));
			if (!cur->text.isEmpty()) {
				qp->setBackgroundMode(OpaqueMode);
				qp->setBackgroundColor(white);
				qp->setPen(black);
				if (cur->y1>cur->y0) qp->drawText(dxtopx(cur->x0),dytopy(cur->y0)+12,cur->text);
				else qp->drawText(dxtopx(cur->x0),dytopy(cur->y0)-5,cur->text);
				qp->setPen(red);
			}
			break;
		case ImShape::DOTBOX:
			qp->drawEllipse(dxtopx(cur->x0+cur->x1/2)-1,dytopy(cur->y0+cur->y1/2)-1,3,3);
		case ImShape::BOX:
			qp->drawRect(dxtopx(cur->x0),dytopy(cur->y0),cur->x1*lscale,-cur->y1*lscale);
			if (!cur->text.isEmpty()) {
				qp->setBackgroundMode(OpaqueMode);
				qp->setBackgroundColor(white);
				qp->setPen(black);
				qp->drawText(dxtopx(cur->x0),dytopy(cur->y0)+12,cur->text);
			}
			break;
		case ImShape::CIRCLE:
		case ImShape::FILL_CIRCLE:
			qp->drawEllipse(dxtopx(cur->x0),dytopy(cur->y0),cur->x1*lscale,-cur->y1*lscale);
			break;
		//centered ellipse, x0 is major radius, y0 is minor radius, userf is angle in degrees
		case ImShape::CENELLIPSE:
			if (data) qp->translate(dxtopx(data->xSize()/2),dytopy(data->ySize()/2));
			else qp->translate(width()/2,height()/2);
			qp->rotate(-cur->userf);
			qp->drawEllipse(-cur->x0,-cur->y0,cur->x0*2,cur->y0*2);
			qp->resetXForm();
//			printf("cene %d %d %1.2f \n",cur->x0,cur->y0,cur->userf);
			break;
		case ImShape::TEXT:
			if (!cur->text.isEmpty()) qp->drawText(dxtopx(cur->x0),dytopy(cur->y0),cur->text);
			break;
		}
		if (cur->type==ImShape::FILL_CIRCLE) qp->setBrush(NoBrush);
	}
	shapes.last();
	shapes.take();
	qp->end();

//	bitBlt( this, 0,0, &qpm2 );
}

}

void SliceImage::paint(int x, int y, int seg) {
	int i,j;
	if (!datar || !segdata) return;
	
	for (i=-drawrad; i<=drawrad; i++) {
		for (j=-drawrad; j<=drawrad; j++) {
			if (i*i+j*j<=drawrad*drawrad && x+i>=0 && y+j>=0 && x+i<datar->xSize() && y+i<datar->ySize())
				segdata->setValueAt(x+i,y+j,0,seg);
		}
	}
	segdata->unum2++;
	imageChanged();
//	printf("paint %d\n",seg);
}

void SliceImage::mouseDoubleClickEvent(QMouseEvent *e) {
int x=e->x(),y=e->y();
//printf("dc\n");
emit doubleclicked(pxtodx(x),pytody(y),drawseg);
};

void SliceImage::mouseEnter(int) { };

void SliceImage::mouseLeave(int) { };

void SliceImage::mousePressEvent(QMouseEvent *e) {
if (!datar) return;
int x=e->x(),y=e->y();
EMData *data = datar;
if (showfft && !(datar->isComplex())) { data=datar->doFFT(); data->ri2ap(); }

if ((e->button()&LeftButton)) {
	if ((e->state()&ShiftButton) && qpm) {
		
		QImageDrag *idr = new QImageDrag(qpm->convertToImage(),this);
		if (idr) idr->dragCopy();
		else printf("Drag error\n");
	}
	else if ((e->state()&ControlButton)) {
		paint(pxtodx(x),pytody(y),0);
	}
	else {
		paint(pxtodx(x),pytody(y),drawseg);
	}
}

if ((e->button()&MidButton) ) {
	if ((e->state()&ShiftButton) && qpm) {
		mode^=1; 
		needupd=1; 
		update(); 
	}
	else {
		if (!imc) {	
			imc=new ImageMxCon; 
			connect(imc,SIGNAL(setBC(float,float)),SLOT(setBC(float,float)));
			connect(imc,SIGNAL(invToggle(int)),SLOT(setInvert(int)));
			connect(imc,SIGNAL(fftToggle(int)),SLOT(setFFT(int)));
			connect(imc,SIGNAL(saveImage()),SLOT(saveImage()));
			connect(imc,SIGNAL(setScale(float)),SLOT(setScale(float)));
			connect(imc,SIGNAL(print()),SLOT(doPrint()));
			connect(imc,SIGNAL(newMode(int)),SLOT(setMode(int)));
			connect(this,SIGNAL(imChanged(EMData *)),imc,SLOT(imageChanged(EMData *)));
			connect(this,SIGNAL(probe(unsigned char *,int,int,int,float)),imc,SLOT(doProbe(unsigned char *,int,int,int,float)));
		}
		imc->setup(brite,cont,invert,-1,-1);
		imc->show();
		imc->raise();
		emit imChanged(data);
		needupd=1;
		update();
	}
}

mdx=e->x();
mdy=e->y();

}

void SliceImage::mouseReleaseEvent(QMouseEvent *e) {
int *a,b;

if ((e->button()&LeftButton)) emit(mouseRelease(e));

mdx=e->x();
mdy=e->y();

}

void SliceImage::mouseMoveEvent(QMouseEvent *e) {
if (!datar) return;

int x,y,sz,nx;
float *d,az,r,a=0,c=0,scale;
EMData *data = datar;
if (showfft && !(datar->isComplex())) { data=datar->doFFT(); data->ri2ap(); }

x=e->x();
y=e->y();

if ((e->state()&LeftButton) && data) {
	if (!(e->state()&ShiftButton)) {
		if (mode==4) {
			unsigned char mx[49];
			float mm,me,b;
			mm=(max-min)/2.0;
			me=(max+min)/2.0;
			b=mm*brite*2.0;
			mm*=(1.0-sqrt(cont));
			memset(mx,0,49);

			x=pxtodx(x);
			y=pytody(y);
			data->renderAmp8(mx,x-3,y-3,7,7,7,1.0,invert?254:1,invert?1:254,me-mm-b,me+mm-b);
			if (data->isComplex()) {
				int x1 = x-data->xSize()/2+1;
				int y1 = y-data->ySize()/2+1;
				if (x1<0) { x1*=-1; y1*=-1; }
				x1*=2;
				y1+=data->ySize()/2;
				emit probe(mx,-1,x-data->xSize()/2+1,y-data->ySize()/2+1,data->valueAtSafe(x1,y1));
			}
			else
				emit probe(mx,-1,x-data->xSize()/2,y-data->ySize()/2,data->valueAtSafe(x,y));
		}
		else if ((e->state()&ControlButton)) {
			paint(pxtodx(x),pytody(y),0);
		}
		else {
			paint(pxtodx(x),pytody(y),drawseg);
		}
	}
	return;
}
/*else if (e->state()&RightButton) {
	setOrigin(originx-(x-mdx),originy+y-mdy);
	needupd=1;
	update();
	mdy=y;
	mdx=x;
}*/
else {
}

}
